import { Subject, takeUntil } from 'rxjs';

function untilDestroy$(componentInstance) {
    if (!componentInstance.destroy$) {
        componentInstance.destroy$ = new Subject();
    }
    return takeUntil(componentInstance.destroy$);
}

function WithDestroy$(options) {
    return (componentClass) => {
        if (options === null || options === void 0 ? void 0 : options.id) {
            console.log(`WithDestroy$ got activated with the following id: `, options === null || options === void 0 ? void 0 : options.id);
        }
        const ngOnDestroy = componentClass.prototype.ngOnDestroy;
        componentClass.prototype.ngOnDestroy = function () {
            // Call the original ngOnDestroy
            ngOnDestroy && ngOnDestroy.call(this);
            // Look for destroy$ subject on the instance
            if (this.destroy$) {
                this.destroy$.next();
                this.destroy$.complete();
            }
        };
    };
}
class ClassWithDestroy$ {
    constructor() {
        this.destroy$ = new Subject();
    }
}

/*
 * Public API Surface of until-destroy
 */

/**
 * Generated bundle index. Do not edit.
 */

export { ClassWithDestroy$, WithDestroy$, untilDestroy$ };
//# sourceMappingURL=ngx-until-destroy.mjs.map
